/*
 * calmwm - the calm window manager
 *
 * Copyright (c) 2004 Marius Aamodt Eriksen <marius@monkey.org>
 * All rights reserved.
 *
 * $Id: util.c,v 1.5 2004/07/08 07:03:03 marius Exp $
 */

#include "headers.h"
#include "calmwm.h"

#define MAXARGLEN 20

int
u_spawn(char *argstr)
{
	char *args[MAXARGLEN], **ap;
	char **end = &args[MAXARGLEN - 1];

	switch (fork()) {
	case 0:
		ap = args;
		while (ap < end && (*ap = strsep(&argstr, " \t")) != NULL)
			ap++;

		*ap = NULL;
		setsid();
		execvp(args[0], args);
		exit(1);		
		break;
	case -1:
		warn("fork");
		return (-1);
	default:
		break;
	}

	return (0);
}
